VAR_GLOBAL CONSTANT
  Sur_poc_adresa:     udint:=107000;
  Sur_pocet:          uint:=101;
END_VAR

TYPE
T_surovina:
 STRUCT
  Kod:string[11];
  Nazev:string[23];
 END_STRUCT
END_TYPE
 

VAR_GLOBAL
  DBX_OK:bool;
  Sur_name at %R65000:                                 // '123456789012         '12345678901234567890123'
        array [0..200] of T_surovina:=[(Kod:='           ', Nazev:='                       '), //0
                                       (Kod:='SMOU001    ', Nazev:='Chlebova               '), //1   (pozice 1 az 9 jsou vyhrazene pro mouky)
                                       (Kod:='SMOU002    ', Nazev:='Zitna                  '), //2
                                       (Kod:='SMOU003    ', Nazev:='Special                '), //3
                                       (Kod:='           ', Nazev:='                       '), //4
                                       (Kod:='           ', Nazev:='                       '), //5
                                       (Kod:='           ', Nazev:='                       '), //6
                                       (Kod:='           ', Nazev:='                       '), //7
                                       (Kod:='           ', Nazev:='                       '), //8
                                       (Kod:='           ', Nazev:='                       '), //9   (pozice 1 az 9 jsou vyhrazene pro mouky)
                                       (Kod:='SOST017    ', Nazev:='Voda                   '), //10
                                       (Kod:='NKVA03     ', Nazev:='Kvas                   '), //11
                                       (Kod:='           ', Nazev:='                       '), //12
                                       (Kod:='           ', Nazev:='                       '), //13
                                       (Kod:='           ', Nazev:='                       '), //14
                                       (Kod:='           ', Nazev:='                       '), //15
                                       (Kod:='           ', Nazev:='                       '), //16
                                       (Kod:='           ', Nazev:='                       '), //17
                                       (Kod:='           ', Nazev:='                       '), //18
                                       (Kod:='           ', Nazev:='Roggenbrot             '), //19
                                       (Kod:='           ', Nazev:='Kmin                   '), //20
                                       (Kod:='           ', Nazev:='Sul                    '), //21
                                       (Kod:='           ', Nazev:='Drozdi                 '), //22
                                       (Kod:='           ', Nazev:='Brotstabil             '), //23
                                       (Kod:='           ', Nazev:='Slunecnice             '), //24
                                       (Kod:='           ', Nazev:='Sezam                  '), //25
                                       (Kod:='           ', Nazev:='Lnene seminko          '), //26
                                       (Kod:='           ', Nazev:='Ovesne vlocky          '), //27
                                       (Kod:='           ', Nazev:='Prazeny jecmen         '), //28
                                       (Kod:='           ', Nazev:='Brambory varen         '), //29
                                       (Kod:='           ', Nazev:='Sul jemna              '), //30
                                       (Kod:='           ', Nazev:='Cesnek platky          '), //31
                                       (Kod:='           ', Nazev:='Cesnek pasta           '), //32
                                       (Kod:='           ', Nazev:='Senna soft             '), //33
                                       (Kod:='           ', Nazev:='Norsky koncent         '), //34
                                       (Kod:='           ', Nazev:='Bavorska smes          '), //35
                                       (Kod:='           ', Nazev:='Ps.mouka manit         '), //36
                                       (Kod:='           ', Nazev:='Bio kamutova m         '), //37
                                       (Kod:='           ', Nazev:='Spaldova mouka         '), //38
                                       (Kod:='           ', Nazev:='Bily jogurt            '), //39
                                       (Kod:='           ', Nazev:='Kontistabil C          '), //40
                                       (Kod:='           ', Nazev:='Amydrin                '), //41
                                       (Kod:='           ', Nazev:='Deaktivovane d         '), //42
                                       (Kod:='           ', Nazev:='kontistabil B          '), //43
                                       (Kod:='           ', Nazev:='rakousko zito          '), //44
                                       (Kod:='           ', Nazev:='rakousko pseni         '), //45
                                       (Kod:='           ', Nazev:='zapara 100             '), //46
                                       (Kod:='           ', Nazev:='special 2              '), //47
                                       (Kod:='           ', Nazev:='psenicny kvas          '), //48
                                       (Kod:='           ', Nazev:='Roggenbrot 2           '), //49
                                       (Kod:='           ', Nazev:='Xtend life             '), //50
                                       (Kod:='           ', Nazev:='Tmavex                 '), //51
                                       (Kod:='           ', Nazev:='Celozrnna zitn         '), //52
                                       (Kod:='           ', Nazev:='Psenicny lepek         '), //53
                                       (Kod:='           ', Nazev:='Uldo slad              '), //54
                                       (Kod:='           ', Nazev:='FRESCH                 '), //55
                                       (Kod:='           ', Nazev:='neznama                '), //56
                                       (Kod:='           ', Nazev:='                       '), //57
                                       (Kod:='           ', Nazev:='                       ')  //58
                                       ];
                                       
  Sur_name0{Public} at Sur_name : T_surovina;           //pro OP
  Sur_name41{Public} at Sur_name[41] : T_surovina;      //pro nacitani nazvu z DBX
  
  PrecitDBX:bool;
  ZapsatDBX:bool;
END_VAR



FUNCTION Suroviny_Z_DBX_do_registru:bool;

 Suroviny_Z_DBX_do_registru:=ReadFromDataBox(variable :=void (Sur_name) ,
                                       dataBoxAddress :=Sur_poc_adresa,
                                               length :=SIZEOF(T_surovina)*Sur_pocet );

END_FUNCTION



FUNCTION Suroviny_Do_DBX_z_registru:bool;

 Suroviny_Do_DBX_z_registru:=WriteToDataBox(variable :=void (Sur_name) ,
                                       dataBoxAddress :=Sur_poc_adresa,
                                               length :=SIZEOF(T_surovina)*Sur_pocet );

END_FUNCTION



PROGRAM prgMain
  VAR_INPUT
  END_VAR
  VAR_OUTPUT
  END_VAR
  VAR
  END_VAR
  VAR_TEMP
  END_VAR
  

  //presun surovin do DBX z registru
  if ZapsatDBX Then
     DBX_OK:=false;
     DBX_OK:=Suroviny_Do_DBX_z_registru();
  end_if;
  ZapsatDBX:=false;


 //presun surovin z DBX do registru
  if PrecitDBX Then
     DBX_OK:=false;
     DBX_OK:=Suroviny_Z_DBX_do_registru();
  end_if;
  PrecitDBX:=false;

END_PROGRAM

